"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtil = __importStar(require("../../src/operationUtils"));
const wrapVueTransformation_1 = __importStar(require("../../src/wrapVueTransformation"));
exports.transformAST = wrapVueTransformation_1.createTransformAST(nodeFilter, fix, 'popover-rename-attribute');
exports.default = wrapVueTransformation_1.default(exports.transformAST);
const renameMap = new Map([
    ['open-delay', 'show-after'],
    ['close-delay', 'hide-after']
]);
function nodeFilter(node) {
    var _a, _b, _c, _d, _e, _f;
    return (node.type === 'VIdentifier' &&
        renameMap.has(node.name) &&
        ((_c = (_b = (_a = node.parent) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.parent) === null || _c === void 0 ? void 0 : _c.type) === 'VElement' &&
        ((_f = (_e = (_d = node.parent) === null || _d === void 0 ? void 0 : _d.parent) === null || _e === void 0 ? void 0 : _e.parent) === null || _f === void 0 ? void 0 : _f.name) === 'el-popover');
}
function fix(node) {
    let fixOperations = [];
    // @ts-ignore
    fixOperations.push(OperationUtil.replaceText(node, renameMap.get(node.name)));
    return fixOperations;
}
